package de.tudresden.inf.st.ros2rag.senderstub;

import de.tudresden.inf.st.ros2rag.starter.ast.MqttUpdater;
import panda.Linkstate;

import java.util.concurrent.TimeUnit;

public class Main {
  public static void main(String[] args) throws Exception {
    final String topic;
    final byte[] message;

    if (args.length < 1) {
      topic = "robot/joint1";
    } else {
      topic = args[0];
    }

    if (args.length < 2) {
      Linkstate.PandaLinkState pls = Linkstate.PandaLinkState.newBuilder()
          .setName("Joint1")
          .setPos(Linkstate.PandaLinkState.Position.newBuilder()
              .setPositionX(0.5f)
              .setPositionY(0.5f)
              .setPositionZ(0.5f)
              .build())
          .setOrient(Linkstate.PandaLinkState.Orientation.newBuilder()
              .setOrientationX(0)
              .setOrientationY(0)
              .setOrientationZ(0)
              .setOrientationW(0)
              .build())
          .build();
      message = pls.toByteArray();
    } else {
      message = args[1].getBytes();
    }

    MqttUpdater sender = new MqttUpdater("sender stub").dontSendWelcomeMessage();
    sender.setHost("localhost", 1883);
    sender.waitUntilReady(2, TimeUnit.SECONDS);
    sender.publish(topic, message);
    sender.close();
  }
}
